package errorstest

import "testing"
import "git.tebibyte.media/fspl/fspl/errors"

func TestError (test *testing.T) {
testError (test,
`example.fspl:11:7: some error
11   | lorem ipsum dolor
             ^^^^^`,
errors.Errorf (
	errors.Position {
		File: "example.fspl",
		Line: "lorem ipsum dolor",
		Row:   10,
		Start:  6,
		End:   11,
	},
	"some error"))
}

func TestErrorTab (test *testing.T) {
testError (test,
`example.fspl:11:8: some error
11   |         lorem   ipsum   dolor
                       ^^^^^`,
errors.Errorf (
	errors.Position {
		File: "example.fspl",
		Line: "\tlorem\tipsum\tdolor",
		Row:   10,
		Start:  7,
		End:   12,
	},
	"some error"))
}

func TestErrorTabInBetween (test *testing.T) {
testError (test,
`example.fspl:11:8: some error
11   |         lorem   ipsum   dolor
                       ^^^^^^^^^`,
errors.Errorf (
	errors.Position {
		File: "example.fspl",
		Line: "\tlorem\tipsum\tdolor",
		Row:   10,
		Start:  7,
		End:   14,
	},
	"some error"))
}
