package generator

import "testing"

func TestConstantValueSpecified (test *testing.T) {
testString (test,
`%"0zNZN147MN2wzMAQ6NS2dQ==::E" = type i64
0zNZN147MN2wzMAQ6NS2dQ==::E.one =  constant %"0zNZN147MN2wzMAQ6NS2dQ==::E" i64 1
0zNZN147MN2wzMAQ6NS2dQ==::E.three =  constant %"0zNZN147MN2wzMAQ6NS2dQ==::E" i64 3
0zNZN147MN2wzMAQ6NS2dQ==::E.two =  constant %"0zNZN147MN2wzMAQ6NS2dQ==::E" i64 2
define void @"0zNZN147MN2wzMAQ6NS2dQ==::[f]"() {
0:
	%1 = load %"0zNZN147MN2wzMAQ6NS2dQ==::E", %"0zNZN147MN2wzMAQ6NS2dQ==::E" @"0zNZN147MN2wzMAQ6NS2dQ==::E.two"
	%2 = call i64 @"0zNZN147MN2wzMAQ6NS2dQ==::[plus4]"(%"0zNZN147MN2wzMAQ6NS2dQ==::E" %1)
	ret void
}
define i64 @"0zNZN147MN2wzMAQ6NS2dQ==::[plus4]"(%"0zNZN147MN2wzMAQ6NS2dQ==::E" %e) {
0:
	%1 = alloca %"0zNZN147MN2wzMAQ6NS2dQ==::E"
	store %"0zNZN147MN2wzMAQ6NS2dQ==::E" %e, ptr %1
	%2 = load %"0zNZN147MN2wzMAQ6NS2dQ==::E", ptr %1
	switch %"0zNZN147MN2wzMAQ6NS2dQ==::E" %2, label %8 [
		%"0zNZN147MN2wzMAQ6NS2dQ==::E" 1, label %5
		%"0zNZN147MN2wzMAQ6NS2dQ==::E" 2, label %6
		%"0zNZN147MN2wzMAQ6NS2dQ==::E" 3, label %7
	]
3:
	%4 = phi i64 [ 5, %5 ], [ 6, %6 ], [ 7, %7 ], [ -1, %8 ]
	ret i64 %4
5:
	br label %3
6:
	br label %3
7:
	br label %3
8:
	br label %3
}
`,
`
E: Int
| one   = 1
| two   = 2
| three = 3

[plus4 e:E]:Int = switch e
	| E.one   5
	| E.two   6
	| E.three 7
	*        -1
[f] = [plus4 E.two]
`)}

func TestConstantValueUnspecified (test *testing.T) {
testString (test,
`%"0zNZN147MN2wzMAQ6NS2dQ==::E" = type i64
0zNZN147MN2wzMAQ6NS2dQ==::E.one =  constant %"0zNZN147MN2wzMAQ6NS2dQ==::E" i64 0
0zNZN147MN2wzMAQ6NS2dQ==::E.three =  constant %"0zNZN147MN2wzMAQ6NS2dQ==::E" i64 2
0zNZN147MN2wzMAQ6NS2dQ==::E.two =  constant %"0zNZN147MN2wzMAQ6NS2dQ==::E" i64 1
define void @"0zNZN147MN2wzMAQ6NS2dQ==::[f]"() {
0:
	%1 = load %"0zNZN147MN2wzMAQ6NS2dQ==::E", %"0zNZN147MN2wzMAQ6NS2dQ==::E" @"0zNZN147MN2wzMAQ6NS2dQ==::E.two"
	%2 = call i64 @"0zNZN147MN2wzMAQ6NS2dQ==::[plus4]"(%"0zNZN147MN2wzMAQ6NS2dQ==::E" %1)
	ret void
}
define i64 @"0zNZN147MN2wzMAQ6NS2dQ==::[plus4]"(%"0zNZN147MN2wzMAQ6NS2dQ==::E" %e) {
0:
	%1 = alloca %"0zNZN147MN2wzMAQ6NS2dQ==::E"
	store %"0zNZN147MN2wzMAQ6NS2dQ==::E" %e, ptr %1
	%2 = load %"0zNZN147MN2wzMAQ6NS2dQ==::E", ptr %1
	switch %"0zNZN147MN2wzMAQ6NS2dQ==::E" %2, label %8 [
		%"0zNZN147MN2wzMAQ6NS2dQ==::E" 0, label %5
		%"0zNZN147MN2wzMAQ6NS2dQ==::E" 1, label %6
		%"0zNZN147MN2wzMAQ6NS2dQ==::E" 2, label %7
	]
3:
	%4 = phi i64 [ 4, %5 ], [ 5, %6 ], [ 6, %7 ], [ -1, %8 ]
	ret i64 %4
5:
	br label %3
6:
	br label %3
7:
	br label %3
8:
	br label %3
}
`,
`
E: Int
| one
| two
| three

[plus4 e:E]:Int = switch e
	| E.one   4
	| E.two   5
	| E.three 6
	*        -1
[f] = [plus4 E.two]
`)}

func TestConstantValueStruct (test *testing.T) {
testString (test,
`%"0zNZN147MN2wzMAQ6NS2dQ==::Cardinal" = type { i64, i64 }
0zNZN147MN2wzMAQ6NS2dQ==::Cardinal.east =  constant %"0zNZN147MN2wzMAQ6NS2dQ==::Cardinal" { i64, i64 } { i64 1, i64 zeroinitializer }
0zNZN147MN2wzMAQ6NS2dQ==::Cardinal.north =  constant %"0zNZN147MN2wzMAQ6NS2dQ==::Cardinal" { i64, i64 } { i64 zeroinitializer, i64 -1 }
0zNZN147MN2wzMAQ6NS2dQ==::Cardinal.south =  constant %"0zNZN147MN2wzMAQ6NS2dQ==::Cardinal" { i64, i64 } { i64 zeroinitializer, i64 1 }
0zNZN147MN2wzMAQ6NS2dQ==::Cardinal.west =  constant %"0zNZN147MN2wzMAQ6NS2dQ==::Cardinal" { i64, i64 } { i64 -1, i64 zeroinitializer }
define void @"0zNZN147MN2wzMAQ6NS2dQ==::[f]"() {
0:
	%1 = alloca %"0zNZN147MN2wzMAQ6NS2dQ==::Cardinal"
	%2 = load %"0zNZN147MN2wzMAQ6NS2dQ==::Cardinal", %"0zNZN147MN2wzMAQ6NS2dQ==::Cardinal" @"0zNZN147MN2wzMAQ6NS2dQ==::Cardinal.west"
	store %"0zNZN147MN2wzMAQ6NS2dQ==::Cardinal" %2, ptr %1
	ret void
}
`,
`
Cardinal: (.x:Int y:Int)
| north = (.      y: -1)
| south = (.      y:  1)
| west  = (.x: -1      )
| east  = (.x:  1      )
[f] = {
	c:Cardinal = Cardinal.west
}
`)}

func TestConstantValueArray (test *testing.T) {
testString (test,
`%"0zNZN147MN2wzMAQ6NS2dQ==::Order" = type [3 x i64]
0zNZN147MN2wzMAQ6NS2dQ==::Order.backward =  constant %"0zNZN147MN2wzMAQ6NS2dQ==::Order" [3 x i64] [i64 2, i64 1, i64 0]
0zNZN147MN2wzMAQ6NS2dQ==::Order.forward =  constant %"0zNZN147MN2wzMAQ6NS2dQ==::Order" [3 x i64] [i64 0, i64 1, i64 2]
0zNZN147MN2wzMAQ6NS2dQ==::Order.none =  constant %"0zNZN147MN2wzMAQ6NS2dQ==::Order" [3 x i64] [i64 0, i64 zeroinitializer, i64 zeroinitializer]
define void @"0zNZN147MN2wzMAQ6NS2dQ==::[f]"() {
0:
	%1 = alloca %"0zNZN147MN2wzMAQ6NS2dQ==::Order"
	%2 = load %"0zNZN147MN2wzMAQ6NS2dQ==::Order", %"0zNZN147MN2wzMAQ6NS2dQ==::Order" @"0zNZN147MN2wzMAQ6NS2dQ==::Order.forward"
	store %"0zNZN147MN2wzMAQ6NS2dQ==::Order" %2, ptr %1
	ret void
}
`,
`
Order: 3:Int
| none     = (0)
| forward  = (0 1 2)
| backward = (2 1 0)
[f] = {
	o:Order = Order.forward
}
`)}
