package generator

import "fmt"
import "git.tebibyte.media/fspl/fspl/llvm"
import "git.tebibyte.media/fspl/fspl/entity"

func (this *generator) generateEvaluated (constant entity.Expression) (llvm.Const, error) {
	switch constant := constant.(type) {
	case *entity.LiteralInt:
		return this.generateEvaluatedInt(constant)
	case *entity.LiteralFloat:
		return this.generateEvaluatedFloat(constant)
	case *entity.LiteralString:
		return this.generateEvaluatedString(constant)
	case *entity.LiteralArray:
		return this.generateEvaluatedArray(constant)
	case *entity.LiteralStruct:
		return this.generateEvaluatedStruct(constant)
	case *entity.LiteralBoolean:
		return this.generateEvaluatedBoolean(constant)
	case *entity.LiteralNil:
		return this.generateEvaluatedNil(constant)
	default:
		panic(fmt.Sprintf (
			"BUG: generator doesnt know about constant %v, ty: %T",
			constant, constant))
	}
}
